unit uZoom;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, Buttons, shellapi;

type
  TformMenuPrincipal = class(TForm)
    Image1: TImage;
    Timer1: TTimer;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Slider: TTrackBar;
    cbSrediste: TCheckBox;
    btSalir: TBitBtn;
    btIniciar: TBitBtn;
    LWEB: TLabel;
    StaticText1: TStaticText;
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure btSalirClick(Sender: TObject);
    procedure btIniciarClick(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
  private
     procedure WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
  public
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.DFM}

procedure TformMenuPrincipal.WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);
begin
   inherited;
   Msg.MinMaxInfo^.ptMinTrackSize := Point(158, 177); // tamao mnimo del formulario
   Msg.MinMaxInfo^.ptMaxTrackSize := Point(350, 350); // tamao mximo del formulario
end;


procedure TformMenuPrincipal.FormResize(Sender: TObject);
begin
  Panel1.Left := (formMenuPrincipal.ClientWidth Div 2) - Panel1.Width div 2;
  Panel1.Top := (formMenuPrincipal.ClientHeight Div 2) - Panel1.Height div 2;
  Image1.Picture := nil;
end;

procedure TformMenuPrincipal.FormDestroy(Sender: TObject);
begin
  Timer1.Interval := 0;
end;

procedure TformMenuPrincipal.Timer1Timer(Sender: TObject);
var
  Srect,Drect,PosForme:TRect;
  iWidth,iHeight,DmX,DmY:Integer;
  iTmpX,iTmpY:Real;
  C:TCanvas;
  hDesktop: Hwnd;
  Kursor:TPoint;
begin
  if not IsIconic(Application.Handle) then
  begin
    hDesktop := GetDesktopWindow;
    GetCursorPos(Kursor);
    PosForme := Rect(formMenuPrincipal.Left, formMenuPrincipal.Top,
        formMenuPrincipal.Left + formMenuPrincipal.Width,
        formMenuPrincipal.Top + formMenuPrincipal.Height);
    //si el cursor del ratn est fuera de la ventana de la aplicacin
    if not PtInRect(PosForme, Kursor) then
    begin
      if Panel1.Visible = True then
        Panel1.Visible := False;
      if Image1.Visible = False then
        Image1.Visible := True;

      iWidth := Image1.Width;
      iHeight := Image1.Height;
      Drect := Rect(0, 0, iWidth, iHeight);

      iTmpX := iWidth / (Slider.Position * 4);
      iTmpY := iHeight / (Slider.Position * 4);

      Srect := Rect(Kursor.x,Kursor.y,Kursor.x,Kursor.y);
      InflateRect(Srect,Round(iTmpX),Round(iTmpY));

      if Srect.Left < 0 then
        OffsetRect(Srect, -Srect.Left, 0);
      if Srect.Top < 0 then
        OffsetRect(Srect, 0, -Srect.Top);
      if Srect.Right > Screen.Width then
        OffsetRect(Srect, -(Srect.Right - Screen.Width), 0);
      if Srect.Bottom > Screen.Height then
        OffsetRect(Srect, 0, -(Srect.Bottom - Screen.Height));

      C := TCanvas.Create;
      try
        C.Handle := GetDC(GetDesktopWindow);
        Image1.Canvas.CopyRect(Drect, C, Srect);
      finally
        ReleaseDC(hDesktop, C.Handle);
        C.Free;
      end;
      if cbSrediste.Checked = True then
      begin // mostrar punto de mira
        with Image1.Canvas do
        begin
          DmX := Slider.Position * 2 * (Kursor.X-Srect.Left);
          DmY := Slider.Position * 2 * (Kursor.Y-Srect.Top);
          MoveTo(DmX - (iWidth div 4),DmY); // -
          LineTo(DmX + (iWidth div 4),DmY); // -
          MoveTo(DmX,DmY - (iHeight div 4)); // |
          LineTo(DmX,DmY + (iHeight div 4)); // |
        end;
      end;
      Application.ProcessMessages;
    end
    else
    begin  //cursor dentro del formulario
      if Panel1.Visible=False then
        Panel1.Visible:=True;
      if Image1.Visible=True then
        Image1.Visible:=False;
    end;
  end;
end;

procedure TformMenuPrincipal.btSalirClick(Sender: TObject);
begin
  close;
end;

procedure TformMenuPrincipal.btIniciarClick(Sender: TObject);
begin
  Timer1.Enabled := true;
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
